#define TEST_DISABLE_UTIL_FUNCS //return PATCH_RET_NOT_PROCESSED;

DWORD Patch___osAtomicDec()
{
TEST_DISABLE_UTIL_FUNCS
	DBGConsole_Msg(0, "osAtomicDec");

	DWORD dwP = (u32)g_qwGPR[REG_a0];
	DWORD dwValue = Read32Bits(dwP);
	DWORD dwRetval;

	if (dwValue != 0)
	{
		Write32Bits(dwP, dwValue - 1);
		dwRetval = 1;
	}
	else
	{
		dwRetval = 0;
	}
	
	g_qwGPR[REG_v0] = (u64)dwRetval;

	return PATCH_RET_JR_RA;
}



DWORD Patch_memcpy()
{
TEST_DISABLE_UTIL_FUNCS
	DWORD dwDst = (u32)g_qwGPR[REG_a0];
	DWORD dwSrc = (u32)g_qwGPR[REG_a1];
	DWORD dwLen = (u32)g_qwGPR[REG_a2];
	DWORD i;

	//DBGConsole_Msg(0, "memcpy(0x%08x, 0x%08x, %d)", dwDst, dwSrc, dwLen);

	for (i = 0; i < dwLen; i++)
	{
		Write8Bits(dwDst + i,  Read8Bits(dwSrc + i));
	}

	// return value of dest
	g_qwGPR[REG_v0] = g_qwGPR[REG_a0];	

	return PATCH_RET_JR_RA;
}

DWORD Patch_strlen()
{
TEST_DISABLE_UTIL_FUNCS
	//static CHAR last[300] = "";
	//CHAR buf[300];
	DWORD i;
	DWORD dwString = (u32)g_qwGPR[REG_a0];

	//for (i = 0; ; i++)
	//{
		//u8 u = Read8Bits(dwString + i);

		//buf[i] = (char)u;

		//if (u == 0)
		//	break;
	//}
	//if (lstrcmpi(last, buf) != 0)
	//{
	//	DBGConsole_Msg(0, "strlen(%s)", buf);
	//	lstrcpyn(last, buf, 300);
	//}

	// Calculate length now:
	for (i = 0; Read8Bits(dwString+i) != 0; i++)
		;

	g_qwGPR[REG_v0] = (s64)(s32)i;

	return PATCH_RET_JR_RA;

}


DWORD Patch_strchr()
{
TEST_DISABLE_UTIL_FUNCS
	//char buf[300];
	DWORD i;
	DWORD dwString = (u32)g_qwGPR[REG_a0];
	DWORD dwMatchChar = (u32)g_qwGPR[REG_a1] & 0xFF;
	DWORD dwSrcChar;
	DWORD dwMatchAddr = 0;

	/*for (i = 0; ; i++)
	{
		dwSrcChar = Read8Bits(dwString + i);

		buf[i] = (char)dwSrcChar;

		if (dwSrcChar == 0)
			break;
	}*/
	//DBGConsole_Msg(0, "strchr('%s', %c) (ra == 0x%08x)", buf, dwMatchChar, (u32)g_qwGPR[REG_ra]);

	for (i = 0; ; i++)
	{
		dwSrcChar = Read8Bits(dwString + i);

		if (dwSrcChar == dwMatchChar)
		{
			dwMatchAddr = dwString + i;
			break;
		}

		if (dwSrcChar == 0)
			break;
	}

	g_qwGPR[REG_v0] = (s64)(s32)dwMatchAddr;

	return PATCH_RET_JR_RA;
}





/*void * bcopy(const void * src, void * dst, len) */
// Note different order to src/dst than memcpy!
DWORD Patch_bcopy()
{
TEST_DISABLE_UTIL_FUNCS
	DWORD dwSrc = (u32)g_qwGPR[REG_a0];
	DWORD dwDst = (u32)g_qwGPR[REG_a1];
	DWORD dwLen = (u32)g_qwGPR[REG_a2];

	//	DBGConsole_Msg(0, "bcopy(0x%08x, 0x%08x, %d)", dwSrc, dwDst, dwLen);


	// Set return val here (return dest)
	g_qwGPR[REG_v0] = g_qwGPR[REG_a1];

	if (dwLen == 0)
		return PATCH_RET_JR_RA;

	if (dwSrc == dwDst)
		return PATCH_RET_JR_RA;

	if (dwDst < dwSrc || dwDst >= (dwSrc + dwLen))
	{
		// Copy forwards
		if (dwLen < 16 || (dwSrc & 3) != (dwDst & 3))
		{
			// Copy bytewise...
			while (dwLen > 0)
			{
				Write8Bits(dwDst,Read8Bits(dwSrc));
				dwSrc++;
				dwDst++;
				dwLen--;
			}
		}
		else
		{
			// Align src/dst to 4 bytes - bit of a hack!
			while ((dwSrc & 3) != 0)
			{
				Write8Bits(dwDst,Read8Bits(dwSrc));
				dwSrc++;
				dwDst++;
				dwLen--;
			}

			// TODO - Cache read/write pointer here
			DWORD * pSrcBase = (DWORD *)ReadAddress(dwSrc);
			DWORD * pDstBase = (DWORD *)WriteAddress(dwDst);
			DWORD dwBlockSize = (dwLen>>2) * 4;

			// We know dwLen is at the very least 16-3
			memcpy(pDstBase, pSrcBase, dwBlockSize);

			dwSrc += dwBlockSize;
			dwDst += dwBlockSize;
			dwLen -= dwBlockSize;

			// Would could update the src/dst counter outside of the loop

			while (dwLen > 0)
			{
				Write8Bits(dwDst,Read8Bits(dwSrc));
				dwSrc++;
				dwDst++;
				dwLen--;
			}
		}
	}
	else
	{
		// Copy backwards
		
		dwDst += (dwLen - 1);
		dwSrc += (dwLen - 1);
		
		if (dwLen < 16 || (dwSrc & 3) != (dwDst & 3))
		{
			// Copy bytewise...
			while (dwLen > 0)
			{
				Write8Bits(dwDst,Read8Bits(dwSrc));
				dwSrc--;
				dwDst--;
				dwLen--;
			}
		}
		else
		{
			// Align src/dst to 4 bytes
					
			// TODO - Perform 4, 16, 32 byte copy here
			while (dwLen > 0)
			{
				Write8Bits(dwDst,Read8Bits(dwSrc));
				dwSrc--;
				dwDst--;
				dwLen--;
			}
		}
		
	}

	return PATCH_RET_JR_RA;

}




